<script setup>
import { toRef, watch } from 'vue';
import { useField } from 'vee-validate';
import { BFormInput } from 'bootstrap-vue';
import vSelect from "vue-select";
const props = defineProps({
  type: {
    type: String,
    default: 'text',
  },
  value: {
    type: [Number, String],
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: null,
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  maxlength: {
    type: Number,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  successMessage: {
    type: String,
    default: '',
  },
  placeholder: {
    type: String,
    default: '',
  },
  options: {
    type: Object,
    default: [],
  },
  
  clearable: {
    type: Boolean,
    default: false,
  },
  
});
// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, 'name');
const value = toRef(props, 'value');

const options = toRef(props, 'options');

watch([value], () => {
  if (value.value) {
    setValue(value.value);
  } else {
    setState({
      value: '',
      touched: false,
      errors: []
    })
  }
})

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {
  value: selectedValue,
  errorMessage,
  handleBlur,
  handleChange,
  setState,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value,
});

const setValueOption = (value) => {
  setValue(value.value)
  handleChange();
}
</script>

<template>
  <div
    class="IpSelectInput"
    :class="{ 'has-error': !!errorMessage, success: meta.valid }"
  >
  <label class="d-block" for="designation">{{ label }} <span class="text-danger">*</span></label>
  
  <v-select class="eb-select" 
  :disabled="disabled"
  :modelValue="selectedValue"
  multiple 
  taggable 
  push-tags 
  :placeholder="placeholder"
  :id="name" />
  <small class="text-danger" v-if="errorMessage">{{errorMessage}}</small>

  </div>
</template>

<style scoped>

</style>
